if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
		exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Orbing Mode", "Better Orbing", "Pref::Server::BetterOrbing::Mode", "list Absolute 0 Relative 1", "Server_BetterOrbing", 1, 0, 0);
}
else if($Pref::Server::BetterOrbing::Mode $= "")
	$Pref::Server::BetterOrbing::Mode = 1;

package BetterOrbing
{
	function Observer::onTrigger(%data, %this, %trig, %tog)
	{
		if(%trig == 0)
			if(%tog)
				%this.speedy = 1;
			else
				%this.speedy = 0;
		else if(%trig == 2)
			if(%tog)
				%this.upLoop = schedule(5, 0, "moveOrbUp", %this, getSimTime());
			else
				cancel(%this.upLoop);
		else if(%trig == 3)
			if(%tog)
				%this.downLoop = schedule(5, 0, "moveOrbDown", %this, getSimTime());
			else
				cancel(%this.downLoop);
		Parent::onTrigger(%data, %this, %trig, %tog);
	}
};
activatePackage("BetterOrbing");

function moveOrbUp(%this, %tick)
{
	cancel(%this.upLoop);
	%this.upLoop = schedule(5, 0, "moveOrbUp", %this, %time = getSimTime());
	if(isEventPending(%this.downLoop))
		return;
	%len = vectorDist(%tick, %time);
	%dist = (%len / 1000) * (40 * (1 + %this.speedy));
	if($Pref::Server::BetterOrbing::Mode)
		%this.setTransform(vectorAdd(%this.getPosition(), vectorScale(%this.getUpVector(), %dist)) SPC getWords(%this.getTransform(), 3, 6));
	else
		%this.setTransform(vectorAdd(%this.getPosition(), "0 0 "@%dist) SPC getWords(%this.getTransform(), 3, 6));
}

function moveOrbDown(%this, %tick)
{
	cancel(%this.downLoop);
	%this.downLoop = schedule(5, 0, "moveOrbDown", %this, %time = getSimTime());
	if(isEventPending(%this.upLoop))
		return;
	%len = vectorDist(%tick, %time);
	%dist = (%len / 1000) * (40 * (1 + %this.speedy));
	if($Pref::Server::BetterOrbing::Mode)
		%this.setTransform(vectorAdd(%this.getPosition(), vectorScale(%this.getUpVector(), -%dist)) SPC getWords(%this.getTransform(), 3, 6));
	else
		%this.setTransform(vectorAdd(%this.getPosition(), "0 0 "@-%dist) SPC getWords(%this.getTransform(), 3, 6));
}